// File:    Admin System.dm
// Demo: EditNero.AdminSystem
// Author:  Edit Nero
//
// Contents:
//   This file contains the code for a basic Admin System for use in games.

mob
	var
		mute = 0
		teleportblock = 0
		O_Mute = 0
		byondmember="No"


mob/var
	tmp
		AFK=0



var
	list
		Muted = list()
		Mutes = list()
		Players = list()
		keys = list()
		ips = list()
		cpu_ids = list()


proc
	AutoCheck()// this is the proc for the AFK check verb.
		set background=1
		sleep(pick(18000,24000,27000,30000,36000))//sleep a random amount of time so players can't predict when the next check is
		for(var/mob/M in world)
			M.AFK=1
		world << output("<b><font size=5><font color=red>AFK Check Initiated, \
		please say something into OOC to avoid being booted!", "output1")
		sleep(500)
		world << output("<b><font size=5><font color=red>10 seconds until you're kicked if you haven't talked!", "output1")
		sleep(100)
		for(var/mob/M in world)
			if(M.AFK)
				world << output("<b>[M] was booted with [round(M.client.inactivity/10)] seconds since last command!", "output1")//if the time is 0-3 seconds they are afk training
				del(M)

mob
	Login()
		..()
		if(src.key==""||src.key==""||src.key=="") //your key(s) go in between the ""
			src.verbs+=typesof(/mob/Admin/verb)
		if(world.host == key)
			src.verbs+=typesof(/mob/Host/verb)






mob/Host/verb
	OOC_Mute()//this verb mutes OOC allowing no one to speak in chat until re-enabled.
		set category = "Staff"
		if(O_Mute == 1)
			O_Mute = 0
			world<<"OOC has been <b>enabled</b>."
			return
		O_Mute = 1
		world<<"OOC has been <b>disabled</b>."


	Mute(mob/player in world)// this verb will mute a player, use again to unmute.
		set category = "Staff"
		set name = "Mute/Unmute"
		player.muted = !player.muted
		if(player.muted)
			// player was muted
			world<<"[player] has been muted!"
		if(!player.muted)
			world<<"<font color=black><B>[player] has been unmuted!</font></B>"
		else

	Announce(t as text)//this announces something to the server.
		set category = "Staff"
		world<<"<b><font size = +1 color = red><center>(Staff)[src]: [t]</font></b></center>"



mob/Admin/verb
	OOC_Mute()//this verb mutes OOC allowing no one to speak in chat until re-enabled.
		set category = "Staff"
		if(O_Mute == 1)
			O_Mute = 0
			world<<"OOC has been <b>enabled</b>."
			return
		O_Mute = 1
		world<<"OOC has been <b>disabled</b>."

	Mute(mob/player in world)// this verb will mute a player, use again to unmute.
		set category = "Staff"
		set name = "Mute/Unmute"
		player.muted = !player.muted
		if(player.muted)
			// player was muted
			world << output("[player] has been muted!", "output1")
		if(!player.muted)
			world<<"<font color=black><B>[player] has been unmuted!</font></B>"
		else

	Edit(obj/O as mob in world)//this verbs allows you to edit vars of players/mobs.
		set category = "Staff"
		var/variable = input("Which var?","Var") in O.vars
		var/default
		var/typeof = O.vars[variable]
		if(isnull(typeof))
			usr << "Unable to determine variable type."
		else if(isnum(typeof))
			usr << "Variable appears to be <b>NUM</b>."
			default = "num"
		else if(istext(typeof))
			usr << "Variable appears to be <b>TEXT</b>."
			default = "text"
		else if(isloc(typeof))
			usr << "Variable appears to be <b>REFERENCE</b>."
			default = "reference"
		else if(isicon(typeof))
			usr << "Variable appears to be <b>ICON</b>."
			typeof = "\icon[typeof]"
			default = "icon"
		else if(istype(typeof,/atom) || istype(typeof,/datum))
			usr << "Variable appears to be <b>TYPE</b>."
			default = "type"
		else if(istype(typeof,/list))
			usr << "Variable appears to be <b>LIST</b>."
			usr << "*** Warning!  Lists are uneditable in s_admin! ***"
			default = "cancel"
		else if(istype(typeof,/client))
			usr << "Variable appears to be <b>CLIENT</b>."
			usr << "*** Warning!  Clients are uneditable in s_admin! ***"
			default = "cancel"
		else
			usr << "Variable appears to be <b>FILE</b>."
			default = "file"
		usr << "Variable contains: [typeof]"
		var/class = input("What kind of variable?","Variable Type",default) in list("text",
			"num","type","reference","icon","file","restore to default","cancel")
		switch(class)
			if("cancel")
				return
			if("restore to default")
				O.vars[variable] = initial(O.vars[variable])
			if("text")
				O.vars[variable] = input("Enter new text:","Text",\
					O.vars[variable]) as text
			if("num")
				O.vars[variable] = input("Enter new number:","Num",\
					O.vars[variable]) as num
			if("type")
				O.vars[variable] = input("Enter type:","Type",O.vars[variable]) \
					in typesof(/mob)
			if("reference")
				O.vars[variable] = input("Select reference:","Reference",\
					O.vars[variable]) as mob|obj|turf|area in world
			if("file")
				O.vars[variable] = input("Pick file:","File",O.vars[variable]) \
					as file
			if("icon")
				O.vars[variable] = input("Pick icon:","Icon",O.vars[variable]) \
					as icon

	OwnerOOC(msg as text)//this verb is for the owner of the game and displays (Owner) beside the users name.
		set category = "Staff"
		world<<"<font color=black size=3><b>(Owner) [usr]: [msg] </b>"

	IPlist()//this verb shows a list of ips of the users in-game.
		set category = "Staff"
		for(var/mob/M in world)
			if(M.client)
				usr<<"<b><font color=blue><center>[M] : [M.client.address]"

	Teleport()//this verb allows you to teleport to a player currently online or to a location on the map using x,y,z.
		set category = "Staff"
		switch(input("Please select a method of Teleportation!") in list("Location","Player","Teleport someone else","Cancel"))
			if("Location")
				loc = locate(input("X") as num,input("Y") as num,input("Z") as num)
			if("Player")
				var/list/Players = list()
				for(var/mob/M in world)
					Players.Add(M)
				var/mob/M = input("Select a Player!") in Players
				loc = M.loc
			if("Teleport someone Else")
				var/Teleport = locate(input("X") as num,input("Y") as num,input("Z") as num)
				var/list/Players = list()
				for(var/mob/M in world)
					Players.Add(M)
				var/mob/M = input("Select a Player!") in Players
				M.loc = Teleport

	Announce(t as text)
		set category = "Staff"
		world<<"<b><center><font size = +1 color = red>(Staff)[src]: [t]</font></b></center>"

	Boot()//this verb will boot a player from your game.
		set category = "Staff"
		var/Reason = input("Give a reason!") as text
		if(Reason == "")return
		var/list/Players = list()
		for(var/mob/M in world)
			Players.Add(M)
		var/mob/M = input("Select a Player!") in Players
		world<<"<b><font size = +1 color = black>[M] was booted for [Reason]</font></b>"
		del(M)

	Reboot()//this verb reboots the server.
		set category = "Staff"
		if(alert("You wish to continue?","","No","Yes") == "No")return
		if("Yes")
			world<<"<b><font size= 2><font color=black><center>Rebooting..</b></font></center>"
		world.Reboot()

	Summon()//this verb will summon a player to your location.
		set category = "Staff"
		var/list/Players = list()
		if(z==3)
			return
		for(var/mob/M in world)
			Players.Add(M)
		var/mob/M = input("Select a Player!") in Players
		if(teleportblock)
			return
		M.loc = loc


	Delete(M as mob|obj|turf in view(src))//this verb allows you to delete a mob/obj/turf.
		set category = "Staff"
		del(M)

	Rename(mob/M as mob in world, ID as text)//this verb allows you to rename a player currently online.
		set category="Staff"
		for(var/mob/N in world)
			if(N.name==""||N.name==null||N.name==0)
				N.name="NameLess"
				usr<<"<font color=red>Found Nameless. Renamed to NameLess. Key: [N.key]"
		M.name=ID
		usr<<"You <font color = black>changed</font> [M]'s name."
		return

	AFKCheck()//this verb wil intialize a afk check, if you don't say something in ooc within the alloted time it will boot you. Increase time by changing sleep(whatever #)
		set category="Staff"
		for(var/mob/M in world)
			M.AFK=1
		world<<"<b><font size=3><font color=yellow>AFK Check Initiated, \
		please say something into OOC to avoid being booted!"
		sleep(100)
		world<<"<b><font size=3><font color=red>10 seconds until you're kicked IF you haven't talked!"
		sleep(100)
		for(var/mob/M in world)
			if(M.AFK)
				del(M)

	Player_Lookup()//this verb looks up a specific player online telling you their IP, Key, and if they are a Byond member.
		set category="Staff"
		var/K=input("How do you wanna look up a player?")in list("In List","All")
		switch(K)
			if("All")
				for(var/mob/M in world)
					if(M.client)
						usr<<"<br><b>Name: [M.name]<br>IP Address: [M.client.address]<br>Key: [M.key]<br>BYOND Member: [byondmember]<br>"
			if("List")
				var/list/Menu = list()
				for(var/mob/M in world)
					if(M.client)
						if(M.name != usr.name)
							Menu.Add(M)
				var/mob/M=input("Who do you wish to lookup?")as null|anything in Menu
				if(!M)return
				if(istype(M,/mob/))
					usr<<"<br><b>Name: [M.name]<br>IP Address: [M.client.address]<br>Key: [M.key]<br>BYOND Member: [byondmember]<br>"

	World_Info()//this verb shows you the server info.
		set category="Staff"
		set name = "World Info"
		set desc = "See the server's information"
		usr<<"* Server information *"
		usr<<"Address\t: [world.address]:[world.port]"
		usr<<"Computer\t: [world.system_type]"
		usr<<"CPU Usage\t: [world.cpu]"
		usr<<"Uptime\t\t: [(world.time)]"
		usr<<"Status\t\t: <br>\[[world.status]]"



